$ResourceGroupName = 'PlayGround'
$AutomationAccountName = 'MYAzureAutomation'
$ModuleName = 'psexcel'
    
Write-Output "Checking if module '$ModuleName' exists"
$Url = "https://www.powershellgallery.com/api/v2/Search()?`$filter=IsLatestVersion&searchTerm=%27$ModuleName%27&targetFramework=%27%27&includePrerelease=false&`$skip=0&`$top=40" 

# This gives you the Moduledetails
$Moduledetails = Invoke-RestMethod -Method Get -Uri $Url -UseBasicParsing

# Now lets do some split/trim functions to get the version of the module
$moduleversion = ((($Moduledetails.id).Split('Version=')[-1]).Trimend(')')).Trim([Char]0x0027)

# Contruct the module content URL
$ModuleContentUrl = "https://www.powershellgallery.com/api/v2/package/$ModuleName/$ModuleVersion"

# And here comes the magic !! - find the blob storage space where the ZIP File of the module is stoired
$Bloburl = (Invoke-WebRequest -Uri $ModuleContentUrl -MaximumRedirection 0 -UseBasicParsing -ErrorAction Ignore).Headers.Location 

# So now we know the location of the nuget Package, we can install the Module
New-AzureRmAutomationModule `
            -ResourceGroupName $ResourceGroupName `
            -AutomationAccountName $AutomationAccountName `
            -Name $ModuleName `
            -ContentLink $Bloburl
